﻿//●TableReplaceもどき.jsx
//　タブ/改行区切りのテキストデータを（クリップボードに）コピーしてから、そのデータで置き換える表組（内のセル）を選択し、スクリプトを実行します。
//　このスクリプトでは【改行】を改行に置換する機能は省いていますが、（InDesignおよびEXCELの）表組（内のセル）から表組（内のセル）への置換も可能です。
//
//	1.このスクリプトを使用して何らかの損害が生じたとしても、責任は負いかねますので、自己責任で使用して下さい。
//	2.このスクリプトを使い易いように、改変、改良をして同一部署ないで使用するのは構いません。
//	3.このスクリプト及び、改変、改良を加えたスクリプトを無償で再配布する場合にはご連絡ください。
//	4.このスクリプト及び、改変、改良を加えたスクリプトを有償で再配布する事は禁止します。
//
//						2006.12.08　三島梅花藻	/ Mishima Print Co.
//						e-mail：tuchiya☆mishima-print.co.jp	（☆を@に置き換えて下さい。）

CR = String.fromCharCode(13);		//改行
TAB = String.fromCharCode(9);		//タブ
TBL = String.fromCharCode(0x16);	//表組

if (app.selection.length == 1){
	var tblObj = app.selection[0];
	switch (app.selection[0].constructor.name){
		case "Cell":
		case "Table":
		case "Row":
		case "Column":
			break;
		default:
			break label;
	}
	var clipAry = new Array();
	var myDoc = app.activeDocument;
	with (txtfrmObj = myDoc.textFrames.add()){
		visibleBounds = ["0cm","0cm","18cm","21cm"];
		contents = "ダミー";
		app.selection = characters.itemByRange(0,-1);
		app.paste();
		while (characters[-1].contents == CR) characters[-1].remove();	//最後の改行を削除
		var clipstr = "" + contents;
	}
	if (clipstr == TBL){
		clipAry = txtfrmObj.tables[0].contents;
	} else if (clipstr != ""){
		var tmparray = clipstr.split(CR);
		for (var i=0; i < tmparray.length; i++)	clipAry = clipAry.concat(tmparray[i].split(TAB));
	}
	txtfrmObj.remove();
	if (tblObj.cells.length == clipAry.length){
		try {
			tblObj.contents = clipAry;
		}
		catch(e) {
			alert("表組への貼付けに失敗しました。");
		}
	}
	label:
}